﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Kompozyt
{
    class Program
    {
        static void Main(string[] args)
        {
            Kierownik rektor = new Kierownik("Andrzej", "Sokala", "rektor");
            Kierownik dziekan = new Kierownik("Winicjusz", "Drozdowski", "dziekan");
            Kierownik kierownikKatedry = new Kierownik("Rafał", "Adamczak", "kierownik KIS");
            Pracownik pracownik = new Pracownik("Jacek", "Matulewski", "szary pracownik");
            Pracownik drugiPracownik = new Pracownik("Michał", "Joachimiak", "inny pracownik");

            rektor.DodajPodwładnego(dziekan);
            dziekan.DodajPodwładnego(kierownikKatedry);
            kierownikKatedry.DodajPodwładnego(dziekan);
            kierownikKatedry.DodajPodwładnego(pracownik);
            kierownikKatedry.DodajPodwładnego(drugiPracownik);

            //kierownikKatedry.WyświetlInformacje();
            //kierownikKatedry.Resetuj();
            //kierownikKatedry.WyświetlInformacje();

            //kierownikKatedry.PrzyjmijWizytę(new OdwiedzającyWyświetlającyInformacje());
            rektor.PrzyjmijWizytę(new OdwiedzającyWyświetlającyInformacje());
            
            OdwiedzającyLiczący odwiedzającyLiczący = new OdwiedzającyLiczący();
            rektor.PrzyjmijWizytę(odwiedzającyLiczący);
            odwiedzającyLiczący.ZwróćLiczbęOdwiedzin();

            OdwiedzającySpłaszczający odwiedzającySpłaszczający = new OdwiedzającySpłaszczający();
            rektor.PrzyjmijWizytę(odwiedzającySpłaszczający);
            var a = odwiedzającySpłaszczający.Pracownicy;

            IEnumerable<string> zapytanie = from IPracownik p in rektor                                            
                                            select p.ToString();
            string[] b = zapytanie.ToArray();
            int liczbaPracowników = rektor.Count();
            int i = 1;            

            !!!!zanim zdefiniujesz iterator, przećwicz go na liście - odtwórz pętlę foreach
        }
    }
}
